<?xml version="1.0"?>
<!--
 =========================================================================== 
 Mind Raider - Semantic Web outliner
 Copyright (C) 2002,2005  Martin Dvorak
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ===========================================================================
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"  
                version="1.0">

    <xsl:output method="text"/>

    <xsl:template match="/">
        <xsl:text></xsl:text>
        <xsl:apply-templates select="resource/data/conceptTreeProperty">
        </xsl:apply-templates>
    </xsl:template>
    
    <xsl:template match="resource/data/conceptTreeProperty">
      <xsl:text>---+ </xsl:text>
      <xsl:value-of select="./resource/data/labelProperty/text()"/>
      <xsl:text>
      
*Table of Contents*
%TOC%

</xsl:text>

        <xsl:apply-templates select="conceptTreeProperty">
          <xsl:with-param name="SECTION" select="'---++'"/>
        </xsl:apply-templates>
    </xsl:template>



    <xsl:template match="conceptTreeProperty">
      <xsl:param name="SECTION"/>
<xsl:value-of select="$SECTION"/>
<xsl:text> </xsl:text>
      <xsl:value-of select="./resource/data/labelProperty/text()"/>
      <xsl:text>
</xsl:text>
      <xsl:value-of select="./resource/data/annotationProperty/text()"/>

      <xsl:apply-templates select="./conceptTreeProperty">
        <xsl:with-param name="SECTION" select="concat($SECTION,'+')"/>
      </xsl:apply-templates>
    </xsl:template>

</xsl:stylesheet>
