<?xml version="1.0"?>
<!--
 =========================================================================== 
 Mind Raider - Semantic Web outliner
 Copyright (C) 2002,2005  Martin Dvorak
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ===========================================================================
-->
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:strip-space elements="*"/>
  <xsl:output method="xml" indent="yes"/>

    <xsl:template match="/">
        <xsl:apply-templates select="resource/data/conceptTreeProperty">
        </xsl:apply-templates>
    </xsl:template>
    
    <xsl:template match="resource/data/conceptTreeProperty">
      <rdf:RDF
        xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
        xmlns:skos="http://www.w3.org/2004/02/skos/core#"
        xmlns:rdfs="http://www.w3.org/2000/01/rdf-schema#">

        <skos:Concept rdf:about="{./resource/metadata/uri/text()}">        
          <skos:prefLabel><xsl:value-of select="./resource/data/labelProperty/text()"/></skos:prefLabel>
          <skos:definition>
          <skos:narrower>
            <skos:OrderedCollection>
              <rdfs:label>people by age</rdfs:label>
              <skos:memberList rdf:parseType="Collection">
                <skos:Concept rdf:about="http://www.example.com/concepts#infants"/>
                <skos:Concept rdf:about="http://www.example.com/concepts#children"/>
                <skos:Concept rdf:about="http://www.example.com/concepts#adults"/>
              </skos:memberList>
            </skos:OrderedCollection>
          </skos:narrower>
        </skos:Concept>

      </rdf:RDF>






      <opml version="1.1">
      <head>
         <title>OPML generated by MindRaider (http://mindraider.sourceforge.net)</title>
         <!--
         <dateCreated>23.4.05 11:15</dateCreated>
         <ownerName>dvorka</ownerName>
         -->
       </head>

       <body>    
        <outline>
         <xsl:attribute name="title">
           <xsl:value-of select="./resource/data/labelProperty/text()"/>
         </xsl:attribute>
         <xsl:attribute name="text">
           <xsl:value-of select="./resource/data/labelProperty/text()"/>
         </xsl:attribute>

           <xsl:apply-templates select="conceptTreeProperty">
           </xsl:apply-templates>

        </outline>
       </body>
      </opml>

    </xsl:template>



    <xsl:template match="conceptTreeProperty">
         <outline>
           <xsl:attribute name="title">
             <xsl:value-of select="./resource/data/labelProperty/text()"/>
           </xsl:attribute>
           <xsl:attribute name="text">
             <xsl:value-of select="./resource/data/labelProperty/text()"/>
           </xsl:attribute>
           <xsl:attribute name="xmlUrl">
             <xsl:value-of select="./resource/metadata/uri/text()"/>
           </xsl:attribute>
           <!-- TODO: add attachments in here in the future -->

         <outline>
           <xsl:attribute name="title">
             <xsl:value-of select="./resource/data/labelProperty/text()"/>
           </xsl:attribute>
           <xsl:attribute name="text">
             <xsl:value-of select="./resource/data/annotationProperty/text()"/>
           </xsl:attribute>
           <xsl:attribute name="description">
             <xsl:value-of select="./resource/data/annotationProperty/text()"/>
           </xsl:attribute>
           <xsl:attribute name="xmlUrl">
             <xsl:value-of select="./resource/metadata/uri/text()"/>
           </xsl:attribute>
           <xsl:attribute name="isComment">
             <xsl:value-of select="'true'"/>
           </xsl:attribute>
         </outline>

           <xsl:apply-templates select="./conceptTreeProperty">
           </xsl:apply-templates>

         </outline>

    </xsl:template>

</xsl:stylesheet>